ScriptName LNDatingTheCommonwealth:LNMagnoliaPlayerDatingScript extends Quest conditional

; Sleep Intimate patch, SleepIntimate_LNDatingPatch by DracoTorre - https://www.nexusmods.com/fallout4/mods/35637?
;   original script created by LoopyNoopy for "Dating Magnolia" at https://www.nexusmods.com/fallout4/mods/16840
; 
;   Hotel Rex location now plays animated scene at orignal Hotel Rex location (not the LN copy cell)
;	VIP room remains the same with LN fade-out

;-- Properties --------------------------------------
Quest Property DialogueGoodnieghborQuest auto const
ObjectReference Property LNHotelRexfordRoomMagnoliaStart Auto Const
{ patch expects DTSleep Magnolia start marker }
ObjectReference Property LNHotelRexfordRoomPlayerEntrance Auto Const
{ patch expects DTSleep Player start marker }
Actor Property MagnoliaProp Auto Const
ObjectReference Property LNHotelRexfordMagnoliaExit Auto Const
ObjectReference Property LNHotelRexfordPlayerExit Auto Const
Spell Property LoversEmbraceProp Auto Const
Scene Property LNMagnoliaPlayerInitiateDate Auto Const
Cell Property LNHotelRexfordRoom Auto Const
Scene Property LNMagnoliaPlayerDatingSexScene Auto Const
int Property LNMagnoliaPlayerLocation Auto conditional
{ 1 = Hotel rexford
2 = VIP room }
ObjectReference Property LNVIPRoomMagStart Auto Const
ObjectReference Property LNVIPRoomPlayerStart Auto Const
ObjectReference Property LNVIPRoomMagExit Auto Const
ObjectReference Property LNVIPRoomPlayerExit Auto Const
Scene Property MagnoliaSong1 Auto Const
Scene Property MagnoliaSong2 Auto Const
Scene Property MagnoliaSong3 Auto Const
Scene Property MagnoliaSong4 Auto Const
Scene Property MagnoliaSong5 Auto Const

; added properties
ObjectReference Property VIPRoomSofaRef auto const

;-- added patch Variables ---------------------------------------


;-- Functions ---------------------------------------

Function LNMagnoliaPlayerVIPRoomExit()
	; patch: VIP room runs normal 
	inputenablelayer myLayer = inputenablelayer.Create()
	Actor myPlayer = Game.GetPlayer()
	Actor MagnoliaREF = MagnoliaProp
	myLayer.DisablePlayerControls(True, True, False, False, False, True, True, False, True, True, False)
	Utility.Wait(0.1)
	MagnoliaREF.Moveto(LNVIPRoomMagExit, 0, 0, 0, True)
	myPlayer.Moveto(LNVIPRoomPlayerExit, 0, 0, 0, True)
	Utility.Wait(0.1)
	Game.FadeOutGame(False, True, 0, 3, False)
	Utility.Wait(3)
	if (!myPlayer.HasSpell(LoversEmbraceProp))
		LoversEmbraceProp.Cast(myPlayer as ObjectReference, myPlayer as ObjectReference)
	endIf
	; patch: added enable and delete
	myLayer.EnablePlayerControls()
	myLayer.Delete()
	myLayer = None
	LNMagnoliaPlayerLocation = 0
	Self.MagnoliaRandomSong()
EndFunction

Function LNMagnoliaPlayerVIPRoomStart()
	inputenablelayer myLayer = inputenablelayer.Create()
	Actor myPlayer = Game.GetPlayer()
	Actor MagnoliaREF = MagnoliaProp
	myLayer.DisablePlayerControls(True, True, False, False, False, True, True, False, True, True, False)
	Game.FadeOutGame(True, True, 0, 3, True)
	Utility.Wait(5)
	Utility.Wait(0.1)
	myPlayer.Moveto(LNVIPRoomPlayerStart, 0, 0, 0, True)
	Game.FadeOutGame(False, True, 0, 3, False)
	Utility.Wait(3 as float)
	MagnoliaREF.Moveto(LNVIPRoomMagStart, 0, 0, 0, True)
	Utility.Wait(3)
	; patch: added enable and delete
	myLayer.EnablePlayerControls()
	myLayer.Delete()
	myLayer = None
	;if (DialogueGoodnieghborQuest != None && VIPRoomSofaRef != None)
	;	(DialogueGoodnieghborQuest as DialogueGoodneighborScript).OurBedRef = VIPRoomSofaRef
	;endIf
	; added for patch
	LNMagnoliaPlayerLocation = 2
EndFunction

Function MagnoliaRandomSong()
	int random = Utility.RandomInt(1, 5)
	If (random == 1)
		MagnoliaSong1.Start()
	ElseIf (random == 2)
		MagnoliaSong2.Start()
	ElseIf (random == 3)
		MagnoliaSong3.Start()
	ElseIf (random == 4)
		MagnoliaSong4.Start()
	ElseIf (random == 5)
		MagnoliaSong5.Start()
	EndIf
EndFunction

Function LNMagnoliaPlayerHRexfordExit()
	; patch: now placing characters in original room - no MoveTo for stability
	;inputenablelayer myLayer = inputenablelayer.Create()
	;Actor myPlayer = Game.GetPlayer()
	;Actor MagnoliaREF = MagnoliaProp
	;myLayer.DisablePlayerControls(True, True, False, False, False, True, True, False, True, True, False)
	;Utility.Wait(0.1)
	;MagnoliaREF.Moveto(LNHotelRexfordMagnoliaExit, 0, 0, 0, True)
	;myPlayer.Moveto(LNHotelRexfordPlayerExit, 0, 0, 0, True)
	;Utility.Wait(0.1)
	Game.FadeOutGame(False, True, 0, 3, False)
	Utility.Wait(3.0)
	;LoversEmbraceProp.Cast(myPlayer as ObjectReference, myPlayer as ObjectReference)
	;myLayer.EnablePlayerControls()
	;myLayer.Delete()
	;myLayer = None
	; added for patch
	LNMagnoliaPlayerLocation = 0
EndFunction

Function LNMagnoliaPlayerHRexfordStart()
	; patch: MoveTo now goes to original hotel - not the LN copy - for stability
	inputenablelayer myLayer = inputenablelayer.Create()
	Actor myPlayer = Game.GetPlayer()
	Actor MagnoliaREF = MagnoliaProp
	myLayer.DisablePlayerControls(True, True, False, False, False, True, True, False, True, True, False)
	Game.FadeOutGame(True, True, 0, 3, True)
	Utility.Wait(4.0)
	myPlayer.Moveto(LNHotelRexfordRoomPlayerEntrance, 0, 0, 0, True)
	;Game.FadeOutGame(False, True, 0, 3, False)
	;Utility.Wait(3.0)
	MagnoliaREF.Moveto(LNHotelRexfordRoomMagnoliaStart, 0, 0, 0, True)
	;Utility.Wait(1.0)
	
	; patch: added enable and delete
	MagnoliaREF.SetRestrained()
	myLayer.EnablePlayerControls()
	myLayer.Delete()
	myLayer = None
	; added for patch
	if (DialogueGoodnieghborQuest != None)
		(DialogueGoodnieghborQuest as DialogueGoodneighborScript).OurBedRef = (DialogueGoodnieghborQuest as DialogueGoodneighborScript).HotelRexfordPlayerBed2REF
	endIf
	
	; patch -- go straight to scene
	LNMagnoliaPlayerLocation = 1
	LNMagNPlayerStartSex()
EndFunction

Function LNMagNPlayerStartSex()
	inputenablelayer myLayer = inputenablelayer.Create()
	Actor myPlayer = Game.GetPlayer()
	myLayer.DisablePlayerControls(True, True, False, False, False, True, True, False, True, True, False)
	Utility.Wait(0.5)
	Game.FadeOutGame(True, True, 0, 1.0, True)

	if (LNMagnoliaPlayerLocation == 1 && DialogueGoodnieghborQuest != None && (DialogueGoodnieghborQuest as DialogueGoodneighborScript).DTSleep_MagnoliaScene != None)
		; only at Hotel Rex
		(DialogueGoodnieghborQuest as DialogueGoodneighborScript).DoPimaryDateFinish = false

		
		(DialogueGoodnieghborQuest as DialogueGoodneighborScript).MagnoliaDateSI(myPlayer)
	else
		LNMagnoliaPlayerDatingSexScene.Start()
		Utility.Wait(2.0)
	endIf
	Utility.Wait(2.0)
	MagnoliaProp.SetRestrained(false)
	
	; patch: added enable and delete
	myLayer.EnablePlayerControls()
	myLayer.Delete()
	myLayer = None
EndFunction
